#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>

#include <console.h>

static GtkWidget *w, *vbox;

struct consolecb {
	void (*cb)(void *, char *);
	void *cbdata;
};

static struct consolecb *makeccb(void (*cb)(void *, char *), void *data) {
	struct consolecb *ret = malloc(sizeof(*ret));

	memset(ret, 0, sizeof(*ret));
	ret->cb = cb;
	ret->cbdata = data;
	return ret;
}

static void trigger_callback(GtkWidget *wo, gpointer data) {
	struct consolecb *cb = data;

	cb->cb(cb->cbdata, NULL);
}

static void window_init() {
	w = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	vbox = gtk_vbox_new(FALSE, 5);
	gtk_container_add(GTK_CONTAINER(w), vbox);
	kmgtk_add_window();
}

static void trigger_add(char *name, void (*cb)(void *, char *), void *data) {
	GtkWidget *b;
	
	if(!w)
		window_init();
	b = gtk_button_new_with_label(name);
	gtk_signal_connect(GTK_OBJECT(b), "clicked",
										 GTK_SIGNAL_FUNC(trigger_callback),
										 makeccb(cb, data));
	gtk_box_pack_start(GTK_BOX(vbox), b, FALSE, FALSE, 5);
	gtk_widget_show(b);
	gtk_widget_show(vbox);
	gtk_widget_show(w);
}

void kmgtk_console_init() {
	kmc_register_hook = trigger_add;
	kmc_enumerate_triggers(trigger_add);
}
