#include <stdlib.h>
#include <gtk/gtk.h>
#include <string.h>

#include <console.h>

#include "gtk-bits.h"

struct clickcb {
	void (*cb)(int, void *);
	void *data;
	int ret;
	struct clickcb *theotherone;	/* it beats digging into the
                                   container, but... ugh */
};

static struct clickcb *makeclickcb(void (*callback)(int, void *),
																	 void *data, int ret) {
	struct clickcb *cb = malloc(sizeof(*cb));

	cb->cb = callback;
	cb->data = data;
	cb->ret = ret;
	return cb;
}

gint delete_event(GtkWidget *w, GdkEvent *e, gpointer data) {
	return 0;
}

void destroy(GtkWidget *w, gpointer data) {
	kmgtk_remove_window();
}

void fish(GtkWidget *wo, gpointer data) {
	struct clickcb *c = data;
	c->cb(c->ret, c->data);
	free(c->theotherone);
	free(c);
}

void doquery(char *str, void (*callback)(int, void *), void *data) {
	GtkWidget *label, *hbox, *vbox, *yes, *no, *w;
	struct clickcb *yescb, *nocb;

	w = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	yescb = makeclickcb(callback, data, 1);
	nocb = makeclickcb(callback, data, 0);
	yescb->theotherone = nocb;
	nocb->theotherone = yescb;
	yes = gtk_button_new_with_label("Yes");
	no = gtk_button_new_with_label("No");
	gtk_signal_connect(GTK_OBJECT(yes), "clicked",
										 GTK_SIGNAL_FUNC(fish), yescb);
	gtk_signal_connect(GTK_OBJECT(no), "clicked",
										 GTK_SIGNAL_FUNC(fish), nocb);
	gtk_signal_connect_object(GTK_OBJECT(no), "clicked",
														GTK_SIGNAL_FUNC(gtk_widget_destroy),
														GTK_OBJECT(w));
	gtk_signal_connect_object(GTK_OBJECT(yes), "clicked",
														GTK_SIGNAL_FUNC(gtk_widget_destroy),
														GTK_OBJECT(w));
	hbox = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start(GTK_BOX(hbox), yes, FALSE, FALSE, 10);
	gtk_box_pack_end(GTK_BOX(hbox), no, FALSE, FALSE, 10);
	label = gtk_label_new(str);
	vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 5);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 5);
	gtk_signal_connect(GTK_OBJECT(w), "delete_event",
										 GTK_SIGNAL_FUNC(delete_event), NULL);
	gtk_signal_connect(GTK_OBJECT(w), "destroy",
										 GTK_SIGNAL_FUNC(destroy), NULL);
	gtk_container_add(GTK_CONTAINER(w), vbox);
	gtk_widget_show(yes);
	gtk_widget_show(no);
	gtk_widget_show(hbox);
	gtk_widget_show(label);
	gtk_widget_show(vbox);
	gtk_widget_show(w);
	kmgtk_add_window();
}

void main_init(void *d, char *a) {
	char arg1[] = "Keymgr Console";
	char *arg[] = { arg1, NULL };
	char **argv = arg;
	int argc = 1;

	if(a && *a)
		setenv("DISPLAY", a, 1);
	else
		if(!getenv("DISPLAY"))
			return;
	gtk_init(&argc, &argv);
	kmc_unregister_trigger("gtk-init");
	kmgtk_console_init();
	kmc_query_hook = doquery;
}

void km_init() {
	if(getenv("DISPLAY"))
		main_init(NULL, NULL);
	else
		kmc_register_trigger("gtk-init", main_init, NULL);
}
	
