#include <stdlib.h>
#include <gtk/gtk.h>

#include <event.h>

#include "gtk-bits.h"

/* you are in a maze of twisty little callbacks, all different */

struct gdkcb {
	void (*cb)(int, void *);
	void *cbdata;
};

struct tagcb {
	struct gdkcb *cb;
	gint tag;
};

static GHashTable *tags;
static int windowcount = 0;

static struct gdkcb *makegdkcb(void (*cb)(int, void *), void *data) {
	struct gdkcb *c = malloc(sizeof(*cb));

	c->cb = cb;
	c->cbdata = data;
	return c;
}

static struct tagcb *maketagcb(struct gdkcb *cb, gint tag) {
	struct tagcb *t = malloc(sizeof(*t));

	t->cb = cb;
	t->tag = tag;
	return t;
}

static void kmgtk_callback(gpointer d, gint fd, GdkInputCondition cond) {
	struct gdkcb *data = d;

	data->cb(fd, data->cbdata);
}
	
static void kmgtk_regr(int fd, void (*cb)(int, void *), void *data) {
	gint tag;
	struct gdkcb *g = makegdkcb(cb, data);
	
	tag = gdk_input_add(fd, GDK_INPUT_READ, kmgtk_callback, g);
	g_hash_table_insert(tags, GINT_TO_POINTER(fd), maketagcb(g, tag));
}
								
static void kmgtk_unregr(int fd) {
	struct tagcb *t = g_hash_table_lookup(tags, GINT_TO_POINTER(fd));

	if(!t)
		return;
	gdk_input_remove(t->tag);
	free(t->cb);
	free(t);
}

static void kmgtk_unregr_enum(int fd, void (*cb)(int, void *), void *data) {
	kmgtk_unregr(fd);
}

void kmgtk_add_window() {
	if(windowcount++)
		return;
	tags = g_hash_table_new(NULL, NULL);
	hookregr = kmgtk_regr;
	hookunregr = kmgtk_unregr;
	hookdispatch = gtk_main;
	ev_enumr(kmgtk_regr);
}

void kmgtk_remove_window() {
	if(--windowcount)
		return;
	hookregr = NULL;
	hookunregr = NULL;
	hookdispatch = NULL;
	ev_enumr(kmgtk_unregr_enum);
	g_hash_table_destroy(tags);
	tags = NULL;
	gtk_main_quit();
}
