#ifndef H_LIBRSA
#define H_LIBRSA

#include <sys/types.h>
#include <gmp.h>

#include "queue.h"

struct kmlr_rsapub {
  unsigned int len;
  mpz_t n;
  mpz_t e;
  char *comment;
};

struct kmlr_rsapriv {
  mpz_t d;
  mpz_t u;
  mpz_t p;
  mpz_t q;
};

typedef void (*kmlr_dcb)(struct kmlr_rsapub *, mpz_t, void *);

struct kmlr_rsakey {
  struct kmlr_rsapub pub;
  struct kmlr_rsapriv priv;
	void (*queryhook)(char *, void (*)(int, void *), void *);
	void (*decrypt)(struct kmlr_rsapub *, mpz_t, kmlr_dcb, void *, void *);
	void *decryptdata;
};

void kmlr_addkey(struct kmlr_rsakey *);
int kmlr_numkeys();
struct rlq *kmlr_match(struct kmlr_rsapub *);
void kmlr_decrypt(struct kmlr_rsapub *, mpz_t, kmlr_dcb, void *);
struct rlq *kmlr_list();

#endif /* !H_LIBRSA */
