#include <sys/types.h>
#include <sys/socket.h>
#include <ctype.h>
#include <unistd.h>
#include <string.h>

#include <keymgr.h>
#include <event.h>
#include <console.h>

static void readcommand(int fd, void *data) {
	char buf[128], *tmp;
	int done, i;

	done = read(fd, buf, 128);
	if(done <= 0) {
		ev_unregr(fd);
		close(fd);
		fd = km_makefifo("console", "KEYMGR_CONSOLE");
		ev_regr(fd, readcommand, NULL);
	}
	if(!(tmp = memchr(buf, '\n', 127)))
		return;
	*tmp++ = 0;
	*tmp = 0;
	for(i = 0; i < done; i++) {
		if(!buf[i]) {
			kmc_call_trigger(buf, NULL);
			return;
		}
		if(isspace(buf[i])) {
			buf[i] = 0;
			kmc_call_trigger(buf, buf + i + 1);
			return;
		}
	}
}

void km_init(char *arg) {
	int fd;

	fd = km_makefifo("console", "KEYMGR_CONSOLE");
	ev_regr(fd, readcommand, NULL);
}
