#include <stdlib.h>

#include "string-num.h"

/* ah, the price we pay for purity of implementation... */

unsigned char kmsl_char_nybble(unsigned char c) {
  switch(c) {
    case '0':
      return 0x0;
    case '1':
      return 0x1;
    case '2':
      return 0x2;
    case '3':
      return 0x3;
    case '4':
      return 0x4;
    case '5':
      return 0x5;
    case '6':
      return 0x6;
    case '7':
      return 0x7;
    case '8':
      return 0x8;
    case '9':
      return 0x9;
    case 'a':
      return 0xa;
    case 'b':
      return 0xb;
    case 'c':
      return 0xc;
    case 'd':
      return 0xd;
    case 'e':
      return 0xe;
    case 'f':
      return 0xf;
    default:
      return -1;
  }
}
       
unsigned char kmsl_str_byte(unsigned char *c) {
  return (kmsl_char_nybble(c[0]) << 4) | kmsl_char_nybble(c[1]);
}

unsigned char *hextable = NULL;

void kmsl_genhextable() {
  int i;

  hextable = malloc(512);
  for(i = 0; i < 256; i++) {
    hextable[i * 2] = kmsl_nybble_char(i >> 4);
    hextable[i * 2 + 1] = kmsl_nybble_char(i & 0xf);
  }
}

unsigned char kmsl_nybble_char(unsigned char c) {
  switch(c) {
    case 0:
      return '0';
    case 1:
      return '1';
    case 2:
      return '2';
    case 3:
      return '3';
    case 4:
      return '4';
    case 5:
      return '5';
    case 6:
      return '6';
    case 7:
      return '7';
    case 8:
      return '8';
    case 9:
      return '9';
    case 0xa:
      return 'a';
    case 0xb:
      return 'b';
    case 0xc:
      return 'c';
    case 0xd:
      return 'd';
    case 0xe:
      return 'e';
    case 0xf:
      return 'f';
    default:
      return 0xff;
  }
}

unsigned char *kmsl_byte_str(unsigned char c) {
  if(!hextable)
    kmsl_genhextable();
  return hextable + 2 * c;
}
